#!/bin/bash
#
# Egyszeru script URL-ek mogotti webtartalom megletenek ellenorzesere.
# A wget spider uzemmodjanak kimenetet adja vissza.
# kovacs.zoltan@mimoza.hu 2005-04-19

AGENT="urlcheck-robot"
EXIT_ERR="1"
SED="/bin/sed"
WGET="/usr/bin/wget"

URL="$1"	# Az ellenorzendo URL
TIMEOUT=$2	# Ennyi ideig var a dokumentum elerhetosegere

if [ -z "$TIMEOUT" ] ; then
    TIMEOUT="30"
fi

if [ ! -z "$URL" ] ; then
    START=`date '+%Y:%m:%d:%H:%M:%S'`
    RESULT=`$WGET "$URL" -nv --spider -U $AGENT -T $TIMEOUT 2>&1`
    END=`date '+%Y:%m:%d:%H:%M:%S'`
    if [ -z "$RESULT" ] ; then
        RESULT="000 Fatal!"
    fi
    echo "$START $END $URL `echo $RESULT |  $SED -n 's/^.*\([[:digit:]]\{3\}\)\(:*\)\(.*$\)/\1\3/p'`"

# Rossz parameterezes eseten emlekezteto

else
	echo "Usage: $0 URL_to_check [ timeout_in_seconds ]"
	exit $EXIT_ERR
fi