#!/bin/bash
#
# Egyszeru script az Apache-ban megadott  virtualhostok folapjai 
# elerhetosegenek tesztelesere.
# kovacs.zoltan@mimoza.hu 2005-04-19

APACHE_DIR="/etc/apache"                	# Apache konfiguracio konyvtara
APACHE_VHOSTS="$APACHE_DIR/conf.d"         	# Apache virtualhostok konfiguracios konyvtara
AWK="/usr/bin/awk"				# Az awk hivasa
EXCEPTURL=""					# | delimitalt lista - deprecated
EXIT_ERR="1"					# Hibajelzes a hivonak
GREP="/bin/grep"				# A grep hvsa
NOCHECK="NOCHECK"                          	# Kizaras jelzese
OK="\( 200 (\)\|\( 200 OK\)"                    # Sikeres lekeres jelzese
SED="/bin/sed"					# A sed hivasa
TIMEOUT="30"                               	# Idotullepes alapertelmezese masodpercekben
URLCHECK="/usr/local/sbin/urlcheck.sh"     	# Egy URL-t ellenorzo script hivasa
URLCHECK_EXC="$APACHE_DIR/urlcheck.exception"	# Kivetelek, soronkent egy csere (opcionalis)
URLCHECK_HOSTS="$APACHE_DIR/urlcheck.hosts"	# Vizsgalando hostok, soronkent egy (opcionalis)

# Alapdolgok ellenorzese.

if [ ! -x "$URLCHECK" ]; then
    echo "Fatal: $URLCHECK isn't found!"
    exit $EXIT_ERR
fi

# Ha meg van adva a host lista, csak azokat ellenorzi, nem foglalkozik a kivetelekkel.
# A host lista soronkent egy servername-et tartalmaz, white space-ek nelkul.
# Ures sorok es # karakterrel kezdodo megjegyzes sorok  megengedettek.

if [ ! -z "`cat $URLCHECK_HOSTS 2>/dev/null | $AWK '{ if ($0 !~ /^#.*/) print $0 }' | $AWK 'NF > 0'`" ] ; then
    cat "$URLCHECK_HOSTS" | \
    $AWK '{ if ($0 !~ /^#.*/) print $0 }' | \
    $AWK 'NF > 0' | while read SRVNM
    do
        if [ -z "echo $SRVNM | $GREP '://'" ]; then 
    	    URL="http://$SRVNM" 
	else
	    URL="$SRVNM/"
	fi
	RESULT=`$URLCHECK $URL $TIMEOUT`

# Minden eredmeny megjelenik a standard kimeneten, a hibak a standard erroron is.

	echo $RESULT 
	echo $RESULT | $GREP -vi "$OK" >&2
    done

# Ha nincs megadva host lista, elokesziti a kiveteleket.
# A kivetelek listaja soronkent egy servername-et es egy helyettesitot tartalmaz.
# Ures sorok es # karakterrel kezdodo megjegyzes sorok  megengedettek.

else
    if [ -r "$URLCHECK_EXC" ] ; then
	EXCEPTURL=`echo -n $EXCEPTURL; cat $URLCHECK_EXC | \
	           $AWK '{ if ($0 !~ /^#.*/) print $0 }' | \
	           $AWK 'NF > 0' | while read LINE
	           do
	              echo "$LINE |"
	           done`
    fi

# Ezutan vegignezi az Apache konfiguraciot, es kiszedi a virtualhostokat.
# Meghatarozza az URL-eket: ha az $EXCEPTURL-ben szerepelnek, csere kell.

    $GREP -Rh "ServerName" $APACHE_VHOSTS  | $GREP -v '#' | $SED -e "s/ServerName//" |while read SRVNM
    do
        URL=`echo $EXCEPTURL | $AWK 'BEGIN { RS = "|" } ; { if ($1 == SRVNM) print $2 }' SRVNM=$SRVNM`
        if [ -z "$URL" ] ; then
	    URL=$SRVNM
	fi

# A kizartak kivetelevel elvegzi az ellenorzest.

	if [ "$URL" != "$NOCHECK" ] ; then
	    if [ -z "echo $URL | $GREP '://'" ]; then 
		URL="http://$URL" 
	    fi
	    RESULT=`$URLCHECK $URL $TIMEOUT`

# Minden eredmeny megjelenik a standard kimeneten, a hibak a standard erroron is.

	    echo $RESULT 
	    echo $RESULT | $GREP -vi "$OK" >&2
	fi
    done
fi
